// ChartLine.cpp: implementation of the CChartLine class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "HTBLineChart.h"
#include "ChartLine.h"
#include "export.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


short CChartLine::m_NextLineID = 0;


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CChartLine::CChartLine()
{

}

CChartLine::~CChartLine()
{

}

CChartLine::CChartLine(short LineNumber, long *pData)
{	m_LineNumber = LineNumber;
	m_pData = pData;
	m_pNext = NULL;
	m_bSignalAbove = FALSE;
	m_bSignalBelow = FALSE;


	m_LineID = m_NextLineID;
	m_NextLineID++;

}

void CChartLine::AddToList(CChartLine *pNewLine)
{
	if (m_pNext == NULL)
	{	m_pNext = pNewLine;
	}
	else
	{	m_pNext->AddToList(pNewLine);
	}
}

short CChartLine::GetID()
{	return(m_LineID);

}

long * CChartLine::GetDataPtr()
{
	return(m_pData);
}

CChartLine * CChartLine::GetNextLine()
{
	return(m_pNext);
}

void CChartLine::SendSignals()
{	if (m_bSignalAbove && *m_pData > m_SignalAboveValue)
	{	Signal(m_SignalAboveNumber);
	}
	
	if (m_bSignalBelow && *m_pData < m_SignalBelowValue)
	{	Signal(m_SignalBelowNumber);
	}

}

void CChartLine::SetSignalAbove(short LineNumber,int Value,short Signal)
{	if (m_LineNumber == LineNumber)
	{	m_bSignalAbove = TRUE;
		m_SignalAboveValue = Value;
		m_SignalAboveNumber = Signal;
	}
	else
	{	m_pNext->SetSignalAbove(LineNumber,Value,Signal);
	}

}

void CChartLine::SetSignalBelow(short LineNumber, int Value, short Signal)
{	if (m_LineNumber == LineNumber)
	{	m_bSignalBelow = TRUE;
		m_SignalBelowValue = Value;
		m_SignalBelowNumber = Signal;
	}
	else
	{	m_pNext->SetSignalBelow(LineNumber,Value,Signal);
	}

}
